# coding: utf-8

"""
    STACKIT DNS API

    This api provides dns

    The version of the OpenAPI document: 1.0
    Contact: dns@stackit.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Annotated, Self


class ImportSummary(BaseModel):
    """
    ImportSummary is the summary of the import.
    """

    created_rr_sets: Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]] = Field(
        default=None, alias="createdRRSets"
    )
    created_records: Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]] = Field(
        default=None, alias="createdRecords"
    )
    deleted_rr_sets: Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]] = Field(
        default=None, alias="deletedRRSets"
    )
    deleted_records: Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]] = Field(
        default=None, alias="deletedRecords"
    )
    updated_rr_sets: Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]] = Field(
        default=None, alias="updatedRRSets"
    )
    updated_records: Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]] = Field(
        default=None, alias="updatedRecords"
    )
    __properties: ClassVar[List[str]] = [
        "createdRRSets",
        "createdRecords",
        "deletedRRSets",
        "deletedRecords",
        "updatedRRSets",
        "updatedRecords",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImportSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImportSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "createdRRSets": obj.get("createdRRSets"),
                "createdRecords": obj.get("createdRecords"),
                "deletedRRSets": obj.get("deletedRRSets"),
                "deletedRecords": obj.get("deletedRecords"),
                "updatedRRSets": obj.get("updatedRRSets"),
                "updatedRecords": obj.get("updatedRecords"),
            }
        )
        return _obj
