# coding: utf-8

"""
    STACKIT DNS API

    This api provides dns

    The version of the OpenAPI document: 1.0
    Contact: dns@stackit.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing_extensions import Self

from stackit.dns.models.record_set import RecordSet


class ListRecordSetsResponse(BaseModel):
    """
    ResponseRRSetAll.
    """

    items_per_page: StrictInt = Field(alias="itemsPerPage")
    message: Optional[StrictStr] = None
    rr_sets: List[RecordSet] = Field(alias="rrSets")
    total_items: StrictInt = Field(alias="totalItems")
    total_pages: StrictInt = Field(alias="totalPages")
    __properties: ClassVar[List[str]] = ["itemsPerPage", "message", "rrSets", "totalItems", "totalPages"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListRecordSetsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rr_sets (list)
        _items = []
        if self.rr_sets:
            for _item in self.rr_sets:
                if _item:
                    _items.append(_item.to_dict())
            _dict["rrSets"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListRecordSetsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "itemsPerPage": obj.get("itemsPerPage"),
                "message": obj.get("message"),
                "rrSets": (
                    [RecordSet.from_dict(_item) for _item in obj["rrSets"]] if obj.get("rrSets") is not None else None
                ),
                "totalItems": obj.get("totalItems"),
                "totalPages": obj.get("totalPages"),
            }
        )
        return _obj
